<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/DirectoryLayout.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/DirectoryLayout.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/DirectoryLayout.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> TOC</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> quote_name, open_file, copy_file</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Tags <span class="py-keyword">import</span> *</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">import</span> os, sys</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html">DirectoryLayout</a> (TOC.Linker):</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">    <span class="py-string">&quot;&quot;&quot;DirectoryLayout defines how the generated html files are organized.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-string">    The default implementation uses a flat layout with all files being part</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-string">    of a single directory.&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#init">init</a>(self, processor):</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        self.processor = processor</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">        self.base = self.processor.output</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.exists(self.base):</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">            <span class="py-keyword">if</span> processor.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: Output directory does not exist. Creating.&quot;</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">            <span class="py-keyword">try</span>:</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">                os.makedirs(self.base, 0755)</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">            <span class="py-keyword">except</span> EnvironmentError, reason:</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">&quot;ERROR: Creating directory:&quot;</span>,reason</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">                sys.exit(2)</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">        <span class="py-keyword">elif</span> <span class="py-keyword">not</span> os.path.isdir(self.base):</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;ERROR: Output must be a directory.&quot;</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">            sys.exit(1)</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">        <span class="py-keyword">if</span> os.path.isfile(processor.stylesheet):</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">            self.copy_file(processor.stylesheet, <span class="py-string">'style.css'</span>)</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;ERROR: stylesheet %s doesn't exist&quot;</span>%processor.stylesheet</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">            sys.exit(1)</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        self.copy_file(os.path.join(config.datadir, <span class="py-string">'logo-small.png'</span>),</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">                       <span class="py-string">'synopsis.png'</span>)</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#copy_file">copy_file</a>(self, src, dest):</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Copy src to dest, if dest doesn't exist yet or is outdated.&quot;&quot;&quot;</span></span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        copy_file(src, os.path.join(self.base, dest))</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#scope">scope</a>(self, scope = None):</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the filename of a scoped name (class or module).</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line"><span class="py-string">        The default implementation is to join the names with '-' and append</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line"><span class="py-string">        &quot;.html&quot;. Additionally, special characters are quoted.&quot;&quot;&quot;</span></span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> scope: <span class="py-keyword">return</span> self.special(<span class="py-string">'global'</span>)</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        <span class="py-keyword">return</span> quote_name(<span class="py-string">'.'</span>.join(scope)) + <span class="py-string">'.html'</span></span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#_strip">_strip</a>(self, filename):</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        <span class="py-keyword">if</span> filename.endswith(<span class="py-string">'/'</span>): filename = filename[:-1]</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        <span class="py-keyword">if</span> filename.startswith(<span class="py-string">'/'</span>): filename = filename[1:]</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-keyword">return</span> filename</span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#file_index">file_index</a>(self, filename):</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the filename for the index of an input file.</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="py-string">        Default implementation is to join the path with '.', prepend '_file.'</span></span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line"><span class="py-string">        and append '.html' &quot;&quot;&quot;</span></span>
<a id="line69"></a><span class="lineno"> 69</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        filename = self._strip(filename)</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'_file.%s.html'</span>%filename.replace(os.sep, <span class="py-string">'.'</span>)</span>
<a id="line72"></a><span class="lineno"> 72</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#file_source">file_source</a>(self, filename):</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the filename for the source of an input file.</span></span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line"><span class="py-string">        Default implementation is to join the path with '.', prepend '_source.'</span></span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line"><span class="py-string">        and append '.html' &quot;&quot;&quot;</span></span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">        file = self._strip(filename)</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'_source.'</span>+file.replace(os.sep, <span class="py-string">'.'</span>)+<span class="py-string">'.html'</span></span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#file_details">file_details</a>(self, filename):</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the filename for the details of an input file.</span></span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line"><span class="py-string">        Default implementation is to join the path with '.', prepend</span></span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line"><span class="py-string">        '_file_detail.' and append '.html' &quot;&quot;&quot;</span></span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'_file_detail.'</span>+self._strip(filename).replace(os.sep, <span class="py-string">'.'</span>)+<span class="py-string">'.html'</span></span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#index">index</a>(self):</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the name of the main index file. Default is index.html&quot;&quot;&quot;</span></span>
<a id="line90"></a><span class="lineno"> 90</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'index.html'</span></span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#special">special</a>(self, name):</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the name of a special file (tree, etc). Default is</span></span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line"><span class="py-string">        _name.html&quot;&quot;&quot;</span></span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'_%s.html'</span>%name</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#scoped_special">scoped_special</a>(self, name, scope, ext=<span class="py-string">'.html'</span>):</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the name of a special type of scope file. Default is to join</span></span>
<a id="line101"></a><span class="lineno">101</span><span class="line"><span class="py-string">        the scope with '.' and prepend '.'+name&quot;&quot;&quot;</span></span>
<a id="line102"></a><span class="lineno">102</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">&quot;_%s%s%s&quot;</span>%(name, quote_name(<span class="py-string">'.'</span>.join(scope)), ext)</span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#xref">xref</a>(self, page):</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the name of the xref file for the given page&quot;&quot;&quot;</span></span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'_xref%d.html'</span>%page</span>
<a id="line109"></a><span class="lineno">109</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#module_tree">module_tree</a>(self):</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the name of the module tree index. Default is</span></span>
<a id="line112"></a><span class="lineno">112</span><span class="line"><span class="py-string">        _modules.html&quot;&quot;&quot;</span></span>
<a id="line113"></a><span class="lineno">113</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'_modules.html'</span></span>
<a id="line115"></a><span class="lineno">115</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#module_index">module_index</a>(self, scope):</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the name of the index of the given module. Default is to</span></span>
<a id="line118"></a><span class="lineno">118</span><span class="line"><span class="py-string">        join the name with '.', prepend '_module' and append '.html' &quot;&quot;&quot;</span></span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-keyword">return</span> quote_name(<span class="py-string">'_module'</span> + <span class="py-string">'.'</span>.join(scope)) + <span class="py-string">'.html'</span></span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/DirectoryLayout.html#link">link</a>(self, decl):</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Create a link to the named declaration. This method may have to</span></span>
<a id="line124"></a><span class="lineno">124</span><span class="line"><span class="py-string">        deal with the directory layout.&quot;&quot;&quot;</span></span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        <span class="py-keyword">if</span> (isinstance(decl, ASG.Scope) <span class="py-keyword">or</span></span>
<a id="line127"></a><span class="lineno">127</span><span class="line">            <span class="py-comment"># If this is a forward-declared class template with known specializations,</span></span>
<a id="line128"></a><span class="lineno">128</span><span class="line">            <span class="py-comment"># we want to treat it like an ASG.Class, as far as formatting is concerned.</span></span>
<a id="line129"></a><span class="lineno">129</span><span class="line">            (isinstance(decl, ASG.Forward) <span class="py-keyword">and</span> decl.specializations)):</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">            <span class="py-comment"># This is a class or module, so it has its own file</span></span>
<a id="line131"></a><span class="lineno">131</span><span class="line">            <span class="py-keyword">return</span> self.scope(decl.name)</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        <span class="py-comment"># Assume parent scope is class or module, and this is a &lt;A&gt; name in it</span></span>
<a id="line133"></a><span class="lineno">133</span><span class="line">        filename = self.scope(decl.name[:-1])</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        fragment = quote_as_id(decl.name[-1])</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        <span class="py-keyword">return</span> filename + <span class="py-string">'#'</span> + fragment</span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html">NestedDirectoryLayout</a>(DirectoryLayout):</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Organizes files in a directory tree.&quot;&quot;&quot;</span></span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#scope">scope</a>(self, scope = None):</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> scope: <span class="py-keyword">return</span> <span class="py-string">'Scopes/global.html'</span></span>
<a id="line143"></a><span class="lineno">143</span><span class="line">        <span class="py-keyword">else</span>: <span class="py-keyword">return</span> quote_name(<span class="py-string">'Scopes/'</span> + <span class="py-string">'/'</span>.join(scope)) + <span class="py-string">'.html'</span></span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#file_index">file_index</a>(self, filename):</span>
<a id="line146"></a><span class="lineno">146</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'File/%s.html'</span>%self._strip(filename)</span>
<a id="line148"></a><span class="lineno">148</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#file_source">file_source</a>(self, filename):</span>
<a id="line150"></a><span class="lineno">150</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'Source/%s.html'</span>%self._strip(filename)</span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#file_details">file_details</a>(self, filename):</span>
<a id="line154"></a><span class="lineno">154</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'FileDetails/%s.html'</span>%self._strip(filename)</span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#special">special</a>(self, name):</span>
<a id="line158"></a><span class="lineno">158</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">        <span class="py-keyword">return</span> name + <span class="py-string">'.html'</span></span>
<a id="line160"></a><span class="lineno">160</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#scoped_special">scoped_special</a>(self, name, scope, ext=<span class="py-string">'.html'</span>):</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        <span class="py-keyword">return</span> quote_name(name + <span class="py-string">'/'</span> + <span class="py-string">'/'</span>.join(scope)) + ext</span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#xref">xref</a>(self, page):</span>
<a id="line166"></a><span class="lineno">166</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'XRef/xref%d.html'</span>%page</span>
<a id="line168"></a><span class="lineno">168</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#module_tree">module_tree</a>(self):</span>
<a id="line170"></a><span class="lineno">170</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'Modules.html'</span></span>
<a id="line172"></a><span class="lineno">172</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/DirectoryLayout/NestedDirectoryLayout.html#module_index">module_index</a>(self, scope):</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> len(scope):</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">'Modules/global.html'</span></span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">            <span class="py-keyword">return</span> quote_name(<span class="py-string">'Modules/'</span> + <span class="py-string">'/'</span>.join(scope)) + <span class="py-string">'.html'</span></span>
<a id="line179"></a><span class="lineno">179</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:17 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
